#include<iostream>

using namespace std;

long long n;
long long a[200001];
long long b,c,d,i;

int main(){

cin >> n;

for(i=0;i<n;i++)
cin >> a[i];

for(i=0;i<n-1;i++){

cin >> b >> c;

}

cout << 0 << '\n';
cout << 0 << '\n';
cout << 0 << '\n';

    return 0;
}